/***********************************************************************************************************************
    Copyright 2004 uja
    Copyright 2004 Trolltech (Qt3)
    This file is part of Otashi.
*************************************************************************************************************************/
// 02.09.2004 uja: erste spielbare Version, lokal, 9 Level, einfacher Joker, Netzhiscore nur mit Desktop-Icon realisierbar
// 05.09.2004 uja: Kreuzjoker, HG-Joker, Formjoker
// 09.09.2004 uja: Umschalter Hiscore lokal / Netz mit Umleitung der gameparm.ini ueber Klasse hiscore
// 12.09.2004 uja: Anpassung an die gamelib von ujagames_qt
// 14.09.2004 uja: Bug bei Kreuzjoker behoben, Chamaeleon, Wandler- und Killersteine, function passt umgeschrieben
// 14.09.2004 uja: 5. Muster, da Level Guru geknackt worden war, Jokerwahrscheinlichkeit angepasst, jetzt 14 Levels
// 15.09.2004 uja: Rollsteine (random:re li ob un) eingebaut
// ======================================================================================================================

// Spielroutinen Otashi (eigentliches Spiel):

#include <stdio.h> // Debug, bleibt drin, weil uja staendig hier bastelt
#include "chips.h"

stein::stein(int v,int h,int p)          { set_parms(v,h,p); }

void stein::set_parms(int v,int h,int p) 
{ 
  vg=v; hg=h; patt=p; 
  if ((vg>=0) && (hg>=0) && (patt>=0)) pic=4*(4*patt+hg)+vg; // normale Steine
  else if ((hg>=0) && (patt<0)) pic=80+hg;                   // einfarbig, nur HG muss stimen
  else if ((patt>=0) && (hg<0)) pic=84+patt;                 // einfarbig, nur Muster muss stimmen
  else if (patt==-2) pic=90;                   // patt=-2, Kreuzjoker
  else if (patt==-3) pic=91;                   // patt=-3, Chamaeleon-Stein
  else if (patt==-4) pic=92;                   // patt=-4, Wandler-Stein
  else if (patt==-5) pic=93;                   // patt=-5, Killer-Stein
  else if (patt==-6) pic=94;                   // patt=-6, rolt Zeile oder Spalte vor oder zurueck
  else pic=89;                                 // einfacher Joker
}

int  stein::get_hg()   { return hg; }
int  stein::get_vg()   { return vg; }
int  stein::get_patt() { return patt; }
int  stein::get_pic()  { return pic; }
void stein::zeige()    { p_sprite->setFrame(pic); p_sprite->show(); }
void stein::loesche()  { p_sprite->hide(); }


chips::chips(QWidget* parent)
{ 
  for (int i=0; i<SMAX; i++) my_stein[i]=new stein(0,0,0);			
  for (int i=0; i<NUMVORRAT; i++)  my_vorrat[i]=new stein(0,0,0);			
  my_timer  =new QTimer(this);
  my_stopper=new QTimer(this); // fuer singleShot
  tic=500;
  zeit=ZEIT0;
  connect(my_timer,SIGNAL(timeout()),this,SLOT(ticken()));                  // Anzeige alle s
  connect(this,SIGNAL(punkte_changed(int)),parent,SLOT(set_punkte(int)));   // Anzeige Punkte
  connect(this,SIGNAL(zeit_changed(int)),parent,SLOT(set_zeit(int)));       // 10-sStoppuhr
  connect(this,SIGNAL(level_changed(QString)),parent,SLOT(set_level(QString))); // Levelanzeige
  my_timer->start(1000);
}

void chips::pause()       { aktiv=false; pausiert=true;  p_pause->show(); p_cursor->hide(); }
void chips::weiter()      { aktiv=true;  pausiert=false; p_pause->hide(); p_cursor->show(); }
void chips::game_over()   { aktiv=false; p_gover->show(); p_cursor->hide(); emit gameover(punkte); }
void chips::reset_timer() {  zeit=ZEIT0; emit ticker_changed(zeit); emit zeit_changed(zeit); }
void chips::moven(int xx,int yy) { if (aktiv) p_cursor->move(xx-DX/2,yy-DY/2); } // Pointer schoen mittig halten
void chips::ticken()      { if (aktiv) { zeit--; emit zeit_changed(zeit); if (zeit<=0) game_over(); } }

void chips::steincopy(stein* von,stein* nach) { nach->set_parms(von->get_vg(),von->get_hg(),von->get_patt()); }


// Leveldarstellung: -------------------------------------------------
bool chips::updat_level(int nr)
{
  QString levelname;
  if (nr<1)      { nvg=2; nhg=2; npatt=2; levelname="Teaser"; }
  else if (nr<2) { nvg=2; nhg=3; npatt=2; levelname="Rookie"; }     // ab hier Sondersteine
  else if (nr<3) { nvg=2; nhg=4; npatt=2; levelname="Starter"; }    
  else if (nr<4) { nvg=3; nhg=3; npatt=2; levelname="Medium"; }
  else if (nr<5) { nvg=2; nhg=2; npatt=5; levelname="On the way"; } 
  else if (nr<6) { nvg=3; nhg=4; npatt=2; levelname="Marching on"; } 
  else if (nr<7) { nvg=3; nhg=3; npatt=3; levelname="Helpliner"; }  
  else if (nr<8) { nvg=2; nhg=3; npatt=5; levelname="2nd Level Supporter"; }
  else if (nr<9) { nvg=2; nhg=4; npatt=4; levelname="Specialist"; }     
  else if (nr<10) { nvg=3; nhg=3; npatt=5; levelname="Expert"; }
  else if (nr<11) { nvg=3; nhg=4; npatt=4; levelname="Professor"; }
  else if (nr<12) { nvg=3; nhg=4; npatt=5; levelname="Freak"; }
  else if (nr<13) { nvg=4; nhg=4; npatt=4; levelname="Guru"; }
  else { nvg=5; nhg=4; npatt=4; levelname="Big Boss "; }
  if (nr<14)  emit level_changed(QString(levelname));
  return (nr<14);
}

bool chips::check_ende()
{
  int i,k=-1;
  for (i=0; i<SMAX; i++) if (is_gueltig(i)) k=i;
  if (k<0) { aktiv=false; my_stopper->singleShot(tic,this,SLOT(game_over())); }
  return (k<0);
}

void chips::updat_vorrat()
{ 
  int i,k,v,h,p;
  for (i=0; i<NUMVORRAT-1; i++) steincopy(my_vorrat[i+1],my_vorrat[i]);
  v=rand()%nvg; h=rand()%nhg; p=rand()%npatt; 
  if (level>1) if (rand()%20<2) // 10% Sondersteine
  { 
    k=level/2;     // alle 2 Level ein neuer Sonderstein
    k=rand()%k;
    switch (k)
    {
      case 0: v=-1; h=-1; p=-1; break; // einfacher Joker
      case 1: v=-1; h=-1; p=-3; break; // Chamaeleon
      case 2: v=-1; h=-1; p=-2; break; // Kreuzjoker
      case 3: v=-1; h=-1; p=-4; break; // Wandler
      case 4: v=-1; h=-1; p=-6; break; // Rolli
      case 5: v=-1; h=-1; p=-5; break; // Killer
      
      default: v=-1; h=-1; p=-3;       // Chamaeleon als Voreinstellung
    }
  }   
  
  if (level>0) // Sondersteine Hintergrund, Pattern - obige Steine werden zu einfachen Jokern 
  { 
    if (rand()%20<1) { v=-1; p=-1; }       // Hintergrund muss stimmen
    if (rand()%20<1) { v=-1; h=-1; }       // Pattern muss stimmen
  }
  // else  { if (rand()%10<3) { v=-1; h=-1; p=-6; } }  // Test neue Steine

  my_vorrat[NUMVORRAT-1]->set_parms(v,h,p);
  for (i=0; i<NUMVORRAT; i++) my_vorrat[i]->zeige(); 
  p_cursor->setFrame(my_vorrat[0]->get_pic());
}  

void chips::setze_chip(int nr) { steincopy(my_vorrat[0],my_stein[nr]); my_stein[nr]->zeige(); updat_vorrat(); }

// -------------------------------------------------------------------------------------------------------------------
// --- Interaktion mit User abgesehen von dem Kleinvieh ganz oben: ----------------------------------------------------

void chips::starte_level()
{ 
  int i,k;
  punkte0=punkte;
  my_stopper->stop();
  if (updat_level(level))
  { 
    srand(time(0)); 
    for (i=0; i<SMAX; i++) { b[i]=0; my_stein[i]->p_sprite->hide(); p_bgsprite[i]->setFrame(0); } 
    for (i=0; i<NUMVORRAT; i++) my_vorrat[i]->set_parms(0,0,0);
    for (i=0; i<NUMVORRAT; i++) updat_vorrat();
    // Startsteine:
    setze_chip(0); setze_chip(XMAX-1); setze_chip(SMAX-XMAX); setze_chip(SMAX-1);
    setze_chip(2*XMAX+2);  
    setze_chip(SMAX-2*XMAX-3); 
    emit punkte_changed(punkte); 
    p_gover->hide();

    k=-1; 
    while (k<0) 
    { for (i=0; i<SMAX; i++) if (is_gueltig(i)) k=i;
      if (k<0) updat_vorrat();
    }  
    reset_timer();
    weiter();
  }
  else game_over();
}

void chips::restart_level() { punkte=punkte0; starte_level(); }
void chips::neues_spiel()   { punkte=0; level=0; starte_level(); }

// timerkette: stein setzen/Punkte berechnen, Cursor/Vorrat loeschen,
// rutschen lassen/neuen Cursor, Zeilen- Level- und Endcheck
void chips::stein_setzen(int nr)
{
  aktiv=false;
  int nachbar,sum=0;
  steincopy(my_vorrat[0],my_stein[nr]);
  my_stein[nr]->zeige();
  nachbar=nr-XMAX; if (nachbar>=0) if (my_stein[nachbar]->p_sprite->isVisible()) sum++;
  nachbar=nr+XMAX; if (nachbar<SMAX) if (my_stein[nachbar]->p_sprite->isVisible()) sum++;
  nachbar=nr-1;    if (nachbar%XMAX<(XMAX-1)) if (my_stein[nachbar]->p_sprite->isVisible()) sum++;
  nachbar=nr+1;    if (nachbar%XMAX>0) if (my_stein[nachbar]->p_sprite->isVisible()) sum++;
  punkte=punkte+5*sum;
  emit punkte_changed(punkte);
  p_cursor->hide();
  my_vorrat[0]->loesche();
  my_stopper->singleShot(tic,this,SLOT(rutschen_lassen()));
}  

void chips::rutschen_lassen()
{
  int i,j,k,liste[SMAX],listek[SMAX];
  bool voll;  
  // vollstaendige Reihen und Spalten suchen:
  liste[0]=0; 

  for (j=0; j<YMAX; j++) // volle Reihen suchen
  { 
    voll=true;
    listek[0]=0; 
    for (i=0; i<XMAX; i++)
    { k=i+XMAX*j;
      if (!my_stein[k]->p_sprite->isVisible()) voll=false;
      else if (my_stein[k]->get_patt()==-2) { listek[0]++; listek[listek[0]]=i; } // Kreuzjokerspalten sammeln
    }
    if (voll) 
    { 
      for (i=0; i<XMAX; i++) { liste[0]++; liste[liste[0]]=j*XMAX+i; }         // Reihe nach regulaerer Delete-Liste 
      if (listek[0]>0) for (k=1; k<=listek[0]; k++)                            // Kreuzjokerspalte      
      for (i=0; i<YMAX; i++) { liste[0]++; liste[liste[0]]=i*XMAX+listek[k]; } // Kreuzjokerspalte zu Delete-Liste
    }  
  }    

  for (i=0; i<XMAX; i++) // volle Spalte suchen:
  { 
    voll=true; 
    listek[0]=0;
    for (j=0; j<YMAX; j++)
    { 
      k=i+j*XMAX;
      if (!my_stein[k]->p_sprite->isVisible()) voll=false;
      else if (my_stein[k]->get_patt()<-1) { listek[0]++; listek[listek[0]]=j; } // Kreuzjokerzeile sammeln
    }
    if (voll) 
    { 
      for (j=0; j<YMAX; j++) { liste[0]++; liste[liste[0]]=j*XMAX+i; }    // Spalte nach regulaerer Delete-Liste 
      if (listek[0]>0) for (k=1; k<=listek[0]; k++)                       // Kreuzjokerreihe       
      for (i=0; i<XMAX; i++) { liste[0]++; liste[liste[0]]=i+listek[k]*XMAX; } // Kreuzjokerreihe zu Delete-Liste
    }  
  }
  // auswerten:
  if (liste[0]>0) for (i=1; i<=liste[0]; i++) { k=liste[i]; b[k]=1; my_stein[k]->loesche(); p_bgsprite[k]->setFrame(1); }
  // check levelende:
  k=0; if (liste[0]>0) { k=1; for (i=0; i<SMAX; i++) if (b[i]==0) k=0; }
  if (k==0) { updat_vorrat(); if (!check_ende()) { my_vorrat[0]->zeige(); p_cursor->show(); aktiv=true; } } 
  else  { level++; punkte=punkte+zeit;  my_stopper->singleShot(tic,this,SLOT(starte_level()));  }
}

// Regelwerk: ===========================================================
// 1. Platz ist frei
// 2. mindestens 1 Nachbar
// 3. 2 von 3 Merkmalen mit den Nachbarn stimmen ueberein
// -- Jokermerkmale sind <0
// ----------------------------------------------------------------------

bool chips::passt(stein* s1,stein* s2)
{ 
  int su=0;
    
  // einer der beiden Steine ist Joker:
  if ((s1->get_patt()<0) && (s1->get_hg()<0) && (s1->get_vg()<0)) su=2; 
  else if ((s2->get_patt()<0) && (s2->get_hg()<0) && (s2->get_vg()<0)) su=2;
  
  // einer der beiden Steine ist HGR-Joker:
  else if ((s1->get_vg()<0) && (s1->get_hg()>=0)) { if (s2->get_hg()==s1->get_hg()) su=2; }  
  else if ((s2->get_vg()<0) && (s2->get_hg()>=0)) { if (s2->get_hg()==s1->get_hg()) su=2; }  
  
  // einer der beiden Steine ist PATT-Joker:
  else if ((s1->get_vg()<0) && (s1->get_patt()>=0)) { if (s2->get_patt()==s1->get_patt()) su=2; }  
  else if ((s2->get_vg()<0) && (s2->get_patt()>=0)) { if (s2->get_patt()==s1->get_patt()) su=2; }  
  
  // normale Auswertung:
  else
  {
    if (s1->get_vg()==s2->get_vg()) su++;
    if (s1->get_hg()==s2->get_hg()) su++; 
    if (s1->get_patt()==s2->get_patt()) su++;
  }
  return (su>1);
}

bool chips::is_gueltig(int nr)
{
  int nachbar,sum=0;
  bool ok=(!my_stein[nr]->p_sprite->isVisible());  // Platz muss frei sein  
  if (ok)
  { 
    nachbar=nr-XMAX; 
    if (nachbar>=0) 
    if (my_stein[nachbar]->p_sprite->isVisible()) { sum++; ok=passt(my_stein[nachbar],my_vorrat[0]); }
  }
  if (ok)
  { 
    nachbar=nr+XMAX; 
    if (nachbar<SMAX)
    if (my_stein[nachbar]->p_sprite->isVisible()) { sum++; ok=passt(my_stein[nachbar],my_vorrat[0]); }      
  }
  if (ok)
  { 
    nachbar=nr-1; 
    if (nachbar%XMAX<(XMAX-1)) 
    if (my_stein[nachbar]->p_sprite->isVisible()) { sum++; ok=passt(my_stein[nachbar],my_vorrat[0]); }
  }
  if (ok)
  { 
    nachbar=nr+1; 
    if (nachbar%XMAX>0) 
    if (my_stein[nachbar]->p_sprite->isVisible()) { sum++; ok=passt(my_stein[nachbar],my_vorrat[0]); }
  }
  if (ok) ok=(sum>0);
  return ok;
}
// --------- Ende Regelwerk V.1 ---------------------------------------------------------------------------

// weitere Sondersteine ausser Jokerarten: zus. Regeln V. 2
// ----------------------------------------------------------

bool chips::chamaeleon(int nr) // alle normalen Steine durchprobieren, wenn passt, umwandeln
{
  int i,j,k;
  bool found=false;
  for (i=0; i<nvg; i++) for (j=0; j<nhg; j++) for (k=0; k<npatt; k++) 
  if (!found) { my_vorrat[0]->set_parms(i,j,k); if (is_gueltig(nr)) found=true; } // Endstein
  if (!found) my_vorrat[0]->set_parms(-1,-1,-3);                                  // alter Stein
  return found;
}

bool chips::wandler(int nr, bool killer) // wandelt alle Nachbarn in denselben Stein um, nimmt irgendeinen Nachbarn
{
  int k;
  bool gewaehlt=false,ok=(!my_stein[nr]->p_sprite->isVisible());  // Platz muss frei sein  
  // neuen Stein waehlen, kann keiner gewaehlt werden, ist der Zug ungueltig:
  if (ok)
  { 
    k=nr-XMAX; 
    if (k>=0) if (my_stein[k]->p_sprite->isVisible()) { steincopy(my_stein[k],my_vorrat[0]);  gewaehlt=true; }   
    k=nr+XMAX; 
    if (k<SMAX) if (my_stein[k]->p_sprite->isVisible()) 
       if ((!gewaehlt) || (rand()%4<3)) { steincopy(my_stein[k],my_vorrat[0]); gewaehlt=true; }
    k=nr-1; 
    if (k%XMAX<XMAX-1) if (my_stein[k]->p_sprite->isVisible()) 
       if ((!gewaehlt) || (rand()%3<2)) { steincopy(my_stein[k],my_vorrat[0]); gewaehlt=true; }
    k=nr+1; 
    if (k%XMAX>0) if (my_stein[k]->p_sprite->isVisible()) 
       if ((!gewaehlt) || (rand()%2<1)) { steincopy(my_stein[k],my_vorrat[0]); gewaehlt=true; } 
    ok=gewaehlt;  
  }
  // alle Nachbarn umfaerben:
  if (ok)
  { 
    k=nr-XMAX; if (k>=0) if (killer) my_stein[k]->loesche(); else { steincopy(my_vorrat[0],my_stein[k]); my_stein[k]->zeige(); }
    k=nr+XMAX; if (k<SMAX) if (killer) my_stein[k]->loesche(); else { steincopy(my_vorrat[0],my_stein[k]); my_stein[k]->zeige(); }
    k=nr-1; if (k%XMAX<XMAX-1) if (killer) my_stein[k]->loesche(); else { steincopy(my_vorrat[0],my_stein[k]); my_stein[k]->zeige(); }
    k=nr+1; if (k%XMAX>0) if (killer) my_stein[k]->loesche(); else { steincopy(my_vorrat[0],my_stein[k]); my_stein[k]->zeige(); }
  }
  return ok;
}

int chips::rollen(int nr) // Brettmusteraenderung! Returnt neue Steinposition und updatet den Vorrat 
{
  int buffsize=XMAX; if (YMAX>XMAX) buffsize=YMAX;
  int i,j,k,ret=-1,xx=nr%XMAX,yy=(nr-xx)/XMAX,ri=0;
  stein* s0=new stein(0,0,0);
  
  // Platz muss frei sein und einen Nachbarn haben, stein faerbt sich in einen der Nachbarn um:
  bool vis,ok=(!my_stein[nr]->p_sprite->isVisible());
  if (ok)
  { 
    ok=false;
    k=nr-XMAX; if (k>=0)   if (my_stein[k]->p_sprite->isVisible()) { ok=true; steincopy(my_stein[k],my_stein[nr]); }   
    k=nr+XMAX; if (k<SMAX) if (my_stein[k]->p_sprite->isVisible()) { ok=true; steincopy(my_stein[k],my_stein[nr]); }
    k=nr-1; if (k%XMAX<XMAX-1) if (my_stein[k]->p_sprite->isVisible()) { ok=true; steincopy(my_stein[k],my_stein[nr]); }; 
    k=nr+1; if (k%XMAX>0)  if (my_stein[k]->p_sprite->isVisible()) { ok=true; steincopy(my_stein[k],my_stein[nr]); };
  }
  
  if (ok)
  { steincopy(my_stein[nr],my_vorrat[0]);
    // Stein einsetzen, noch nicht auswerten:
    my_stein[nr]->zeige();
  
    // Reihe oder Spalte rollen lassen:
    ri=rand()%4;
    switch (ri)
    { 
      case 0: vis=(my_stein[xx]->p_sprite->isVisible());
            if (vis)  steincopy(my_stein[xx],s0); 
            for (i=1; i<YMAX; i++)
	    {  
	      j=i*XMAX+xx;
	      k=j-XMAX;
	      if (my_stein[j]->p_sprite->isVisible()) { steincopy(my_stein[j],my_stein[k]); my_stein[k]->zeige(); }
	      else my_stein[k]->loesche();
            }
	    k=(YMAX-1)*XMAX+xx;
	    if (vis) { steincopy(s0,my_stein[k]); my_stein[k]->zeige(); } else my_stein[k]->loesche();
	    ret=nr-XMAX; if (ret<0) ret=ret+SMAX; 
            break;
	    
      case 1: k=yy*XMAX+XMAX-1;
            vis=(my_stein[k]->p_sprite->isVisible());
            if (vis)  steincopy(my_stein[k],s0); 
            for (i=XMAX-1; i>0; i--)
	    {  
	      j=i+XMAX*yy;
	      k=j-1;
	      if (my_stein[k]->p_sprite->isVisible()) { steincopy(my_stein[k],my_stein[j]); my_stein[j]->zeige(); }
	      else my_stein[j]->loesche();
            }
	    k=yy*XMAX;
	    if (vis) { steincopy(s0,my_stein[k]); my_stein[k]->zeige(); } else my_stein[k]->loesche(); 
	    ret=nr+1; if (ret%XMAX==0) ret=ret-XMAX;
            break;
	    
      case 2: k=(YMAX-1)*XMAX+xx;
            vis=(my_stein[k]->p_sprite->isVisible());
            if (vis)  steincopy(my_stein[k],s0); 
            for (i=YMAX-1; i>0; i--)
	    {  
	      j=i*XMAX+xx;
	      k=j-XMAX;
	      if (my_stein[k]->p_sprite->isVisible()) { steincopy(my_stein[k],my_stein[j]); my_stein[j]->zeige(); }
	      else my_stein[j]->loesche();
            }
	    if (vis) { steincopy(s0,my_stein[xx]); my_stein[xx]->zeige(); } else my_stein[xx]->loesche(); 
	    ret=nr+XMAX; if (ret>=SMAX) ret=ret-SMAX;
            break;
	    
      case 3: k=yy*XMAX;
            vis=(my_stein[k]->p_sprite->isVisible());
            if (vis)  steincopy(my_stein[k],s0); 
            for (i=1; i<XMAX; i++)
	    {  
	      j=i+XMAX*yy;
	      k=j-1;
	      if (my_stein[j]->p_sprite->isVisible()) { steincopy(my_stein[j],my_stein[k]); my_stein[k]->zeige(); }
	      else my_stein[k]->loesche();
            }
	    k=yy*XMAX+XMAX-1;
	    if (vis) { steincopy(s0,my_stein[k]); my_stein[k]->zeige(); } else my_stein[k]->loesche(); 
	    if (nr%XMAX==0) ret=nr+XMAX-1; else ret=nr-1;
            break;
     }
  } 
  return ret; 
}


// --------------------------------------------------------------------------------------------
void chips::klick(int xx,int yy)
{ 
  if (aktiv) 
  { 
    int x=(xx-OFX)/DX,y=(yy-OFY)/DY,nr=x+y*XMAX; 
    if (my_vorrat[0]->get_patt()==-3)      { if (chamaeleon(nr))    stein_setzen(nr); }   // Chamaeleon
    else if (my_vorrat[0]->get_patt()==-4) { if (wandler(nr,false)) stein_setzen(nr); }   // Wandler
    else if (my_vorrat[0]->get_patt()==-5) { if (wandler(nr,true))  stein_setzen(nr); }   // Killer
    else if (my_vorrat[0]->get_patt()==-6) { nr=rollen(nr); if (nr>=0) stein_setzen(nr); } // rollen r,o,l,u
    
    else if (is_gueltig(nr)) stein_setzen(nr);                                      // normaler Stein oder Joker
  }
  else if (pausiert) weiter();
}

void chips::lade_spielstand(int speicher)      
{ 
  aktiv=false;
  QString buff,buff1;
  int bufsize=96,i,k=0;
  QFile fh(SPEICHER);
  if (fh.open(IO_ReadOnly))
  {  
    for (i=0; i<=speicher+1; i++) fh.readLine(buff,bufsize); 
    buff1=buff.section(';',0,0); punkte=buff1.toInt();  
    buff1=buff.section(';',1,1); k=buff1.toInt(); 
    fh.close();
  } 
  level=k;
  starte_level();
}  
    
void chips::speichere_spielstand(int speicher) 
{ 
  int bufsize=96,i,k=speicher+1,nrecs=7;
  QString buff[nrecs+1];
  QString bu1="",bu2="";
  QFile fh(SPEICHER); if (fh.open(IO_ReadOnly)) 
  { for (i=0; i<=nrecs; i++) 
    { fh.readLine(buff[i],bufsize);  
      
    }
    fh.close();
  }  
  buff[k]=bu1.setNum(punkte0)+';'+bu2.setNum(level)+";\n";
  if (fh.open(IO_WriteOnly)) { for (i=0; i<=nrecs; i++) fh.writeBlock(buff[i],buff[i].length()); fh.close(); }
}

void chips::save_settings(int hsc)
{
  QFile file(INIFILE); 
  QString buff,bu,b;
  b.setNum(hsc);
  buff=b+"; hscpath\n";
  if (file.open(IO_WriteOnly)) { file.writeBlock(buff,buff.length()); file.close(); }
}
